/*
	File:		SampleWindows.h

	Contains:	

	Written by: 	

	Copyright:	Copyright  1998-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				10/14/1999	Andy Daniels	
				 7/27/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1				
				 9/01/1998	Andy Daniels	Updated
				 7/01/1998	Eric Simenel	Created
				

*/

#ifndef __SAMPLEWINDOWS__
#define __SAMPLEWINDOWS__
#include <TextEdit.h>
#include <Controls.h>

#pragma mark Single Line & Single Style
OSErr NewSingleLineSingleStyleWindow();
#pragma mark Single Vertical Line & Multiple Styles
OSErr NewSingleLineMultipleStylesWindow();
#pragma mark Single Vertical Line & Multiple Styles
OSErr NewSingleVerticalLineMultipleStylesWindow();
void RotateTheLine(WindowDataPtr wdataP);
#pragma mark Paragraphs
OSErr NewParagraphsWindow();
void BreakTheTextInLines(WindowPtr aWind, WindowDataPtr wdataP);
void SmallerBiggerFont(WindowDataPtr wdataP, Fixed variation);
#pragma mark Highlighting, Carets & Cursor Movements
typedef struct
	{
	UniCharArrayOffset selStart;		// start of the selected block in the line
	UniCharCount selLength;				// length of the selected block
	ATSUTextMeasurement xLineSel;		// graphical position of the line start at x
	ATSUTextMeasurement yLineSel;		//                                     and y
	ItemCount lineNumber;				// which line is this?
	} SelectedBlock;

typedef struct
	{
	Boolean withHilight;				// do we currently have hilighted text
	UniCharArrayOffset caret;			// logical position of the caret
	UniCharCount length;				// length of the selection
	ItemCount numberOfSelectedLines;	// number of lines on which the selection extends
	SelectedBlock *selBlocks;			// array of selected blocks
	} Sample5_PrivateData;

OSErr NewHighlightingCaretsCursorMovementsWindow();
void SetSelectedBlocks(WindowDataPtr wdataP);
void HilightAndOrMove(WindowDataPtr wdataP, long what);
void ActivateSample5Window(WindowPtr theWind, WindowDataPtr wdataP, Boolean active);
void UpdateSample5Window(WindowPtr theWind, WindowDataPtr wdataP);
void DisposeSample5Window(WindowDataPtr wdataP);
void HilightCurrentSelection(WindowDataPtr wdataP);
void UnhilightCurrentSelection(WindowDataPtr wdataP);
void BetterSmallerBiggerFont(WindowDataPtr wdataP, Fixed variation);
#pragma mark Hit Testing
typedef struct
	{
	Boolean withHilight;				//
	UniCharArrayOffset caret;			//
	UniCharCount length;				// these 5 first fields are exactly the same
	ItemCount numberOfSelectedLines;	// as those defined in Sample5_PrivateData
	SelectedBlock *selBlocks;			//
	
	long lastClickTime;					// time and Point of last click to check
	Point lastClickPoint;				// for double-click
	} Sample6_PrivateData;

OSErr NewHitTestingWindow();
UniCharArrayOffset WhereInTextIsThisPoint(WindowDataPtr wdataP, Point thePoint, Boolean *leading);
void ClickInSample6Window(WindowDataPtr wdataP, EventRecord *theEvent);
Boolean GotDoubleClick(WindowDataPtr wdataP, EventRecord *theEvent);
void SelectWord(WindowDataPtr wdataP, UniCharArrayOffset thePos, Boolean leading, UniCharArrayOffset *startSel, UniCharArrayOffset *endSel);
void ModifySelection(WindowDataPtr wdataP, UniCharArrayOffset newStart, UniCharArrayOffset newEnd);

#pragma mark Using the Clipboard
typedef struct
	{
	TEHandle justTheText;
	TEHandle textWithStyl;
	} SimpleQDText;

typedef struct
	{
	ItemCount nbStyles;
	UniCharCount runLengths;
	} ustlResouceStart, *ustlResourcePtr, **ustResourceHdl;

OSErr NewClipboardUsingWindow();
OSErr CreateClipboardWindow();
void DoCopy(WindowDataPtr wdataP);
void DoPaste();
void DoShowClipboard();
void UpdateClipboard();
#pragma mark ATSU Text Box
pascal Boolean myFilter(DialogPtr currentDialog, EventRecord *theEventIn, short *theDialogItem);
OSStatus UpdateUserItem(DialogPtr theDialog);
OSErr ShowATSUITextBox();

#pragma mark Font Menu
typedef struct
	{
	short menuID;
	void *menuLookupCookie;
	MenuHandle theMenu;
	ControlHandle button;
	} Sample9_PrivateData;

typedef struct
	{
	long group;
	ATSUFontFeatureType type;
	ATSUFontFeatureSelector sel;
	ControlHandle *cntlList;
	} FeatureGroup;

extern WindowPtr gFontFeaturesWindow;

OSErr ShowFontMenu();
void DisposeSample9Window(WindowDataPtr wdataP);
short UniqueMenuId();
void ChangeTheFont(WindowDataPtr wdataP);
void DoShowFontFeatures();
void SetUpFontFeaturesWindow(ATSUFontID theFontID, ATSUStyle tempS);
OSStatus CreateFontFeaturesWindow();
void ChangeTheFeature(ControlHandle theControl);

#endif
