/*
	File:		WindowUtilities.cp

	Contains:	

	Written by: 	

	Copyright:	Copyright  1998-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				10/14/1999	Andy Daniels	Give up if GetFNum fails
				 7/27/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1				
				 9/01/1998	Andy Daniels	Updated
				 7/01/1998	Eric Simenel	Created
				

*/

#include <string.h>
#include <ATSUnicode.h>
#include <Windows.h>

#include "SomeUnicodeStuff.h"
#include "WindowUtilities.h"

#include "MoreATSUnicode.h"

WindowDataPtr GetWindowData(WindowPtr theWind)
	{
	WindowDataPtr result = NULL;
	if ((theWind != NULL) && (((WindowPeek)theWind)->windowKind == kApplicationWindowKind))
		result = (WindowDataPtr)GetWRefCon(theWind);
	return result;
	}

WindowDataPtr DefaultWindowDataPtr()
	{
	WindowDataPtr wdataP = (WindowDataPtr)NewPtr(sizeof(WindowData));
	if (wdataP != NULL)
		{
		wdataP->sampleKind = 0;
		wdataP->privateData = NULL;
		wdataP->theUnicodeText = NULL;
		wdataP->uTextLength = -1;
		wdataP->xLocation = ff(10);
		wdataP->yLocation = ff(10);
		wdataP->lineHeight = 0;
		wdataP->numberOfLines = 1;
		wdataP->endOfLines = NULL;
		wdataP->numberOfRuns = -1;
		wdataP->runLengths = NULL;
		wdataP->styles = NULL;
		wdataP->textLayout = NULL;
		}
	return wdataP;
	}

void DisposeWindowDataPtr(WindowDataPtr wdataP)
	{
	if (wdataP->privateData != NULL) DisposePtr((Ptr)wdataP->privateData);
	if (wdataP->theUnicodeText != NULL) DisposePtr((Ptr)wdataP->theUnicodeText);
	if (wdataP->endOfLines != NULL) DisposePtr((Ptr)wdataP->endOfLines);
	if (wdataP->runLengths != NULL) DisposePtr((Ptr)wdataP->runLengths);
	if (wdataP->styles != NULL)
		{
		long i;
		for (i=0; i < wdataP->numberOfRuns; i++)
			if (wdataP->styles[i] != NULL)
				{
				long j;
				for (j=i+1; j < wdataP->numberOfRuns; j++)
					if (wdataP->styles[i] == wdataP->styles[j])
						wdataP->styles[j] = NULL;	// so that we don't try to dispose it again
				ATSUDisposeStyle(wdataP->styles[i]);
				}
		DisposePtr((Ptr)wdataP->styles);
		}
	if (wdataP->textLayout != NULL) ATSUDisposeTextLayout(wdataP->textLayout);
	}

ATSUFontID GetFontIDFromMacFontName(Str255 fontName)
	{
	ATSUFontID result = kATSUInvalidFontID, found;
	short iFONDNumber;
	GetFNum(fontName, &iFONDNumber);
	if (!iFONDNumber) return kATSUInvalidFontID;	// GetFNum return 0 if not found.
	OSStatus status = ATSUFONDtoFontID(iFONDNumber, NULL, &found);
	if (status == noErr) result = found;
	return result;
	}

void TryToSetFontTo(ATSUStyle theStyle, Str255 fontName)
	{
	ATSUFontID theFontID = GetFontIDFromMacFontName(fontName);
	if (theFontID == kATSUInvalidFontID) DebugStr("\p can't find this font");
	else
		{
		OSStatus status = atsuSetFont(theStyle, theFontID);
		if (status != noErr) DebugStr("\p ATSUSetAttributes kATSUFontTag failed");
		}
	}
