/*
	File:		WindowUtilities.h

	Contains:	Simple Apple Text Services For Unicode Imaging (ATSUI) Sample Application

	Written by: 	

	Copyright:	Copyright  1998-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				 7/27/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1				
				 9/01/1998	Andy Daniels	Updated
				 7/01/1998	Eric Simenel	Created
				

*/

#ifndef __WINDOWUTILITIES__
#define __WINDOWUTILITIES__

#ifndef IntToFixed
#define IntToFixed(a)	   ((Fixed)(a) << 16)
#endif

#ifndef ff
#define ff(a)			   IntToFixed(a)
#endif

typedef struct
	{
	long sampleKind;						// to identify the kind of sample (1..8)
	void *privateData;						// some storage

	UniCharArrayPtr theUnicodeText;			// the Text in Unicode
	UniCharCount uTextLength;				// its length
	ATSUTextMeasurement xLocation;			// where it starts drawing at x
	ATSUTextMeasurement yLocation;			//                        and y
	ATSUTextMeasurement maxAscent;			// maximum ascent for the whole text
	ATSUTextMeasurement maxDescent;			// maximum descent for the whole text
	ATSUTextMeasurement lineHeight;			// its line height (maxAscent + maxDescent)
	ItemCount numberOfLines;				// number of lines to draw
	UniCharArrayOffset*	endOfLines;			// positions of the end of line breaks
	ItemCount numberOfRuns;					// number of style runs
	UniCharCount *runLengths;				// array of the lengths of each style run
	ATSUStyle *styles;						// array of styles
	ATSUTextLayout textLayout;				// the resulting text layout
	} WindowData, *WindowDataPtr;

WindowDataPtr GetWindowData(WindowPtr theWind);
WindowDataPtr DefaultWindowDataPtr();
void DisposeWindowDataPtr(WindowDataPtr wdataP);

ATSUFontID GetFontIDFromMacFontName(Str255 fontName);
void TryToSetFontTo(ATSUStyle theStyle, Str255 fontName);

#endif
